<template>
    <div class="home">
        <q-page class="row items-center justify-center background-content">
            <div
                class="home-container col-md-3 col-10 q-mx-sm q-my-lg q-pb-xl"
                v-if="permission.conversation?.list"
            >
                <div class="row q-pb-md">
                    <div class="col-12 q-mt-xl text-center">
                        <q-img src="~/assets/images/helpdesk-white.png" width="50px" />
                    </div>
                </div>
                <div class="row q-py-sm">
                    <div class="col-8 offset-2 text-center">
                        <q-btn
                            class="border-radius-10 q-px-lg font-16 home-btn"
                            no-caps
                            :label="$t('home.chats')"
                            @click="selectPage('chatting')"
                        />
                    </div>
                    <div class="col-8 offset-2 text-center q-pt-sm">
                        <q-btn
                            class="border-radius-10 q-px-lg font-16 home-btn"
                            no-caps
                            :label="$t('home.ongoing')"
                            @click="selectPage('ongoing')"
                        />
                    </div>
                    <div class="col-8 offset-2 text-center q-pt-sm">
                        <q-btn
                            class="border-radius-10 q-px-lg font-16 home-btn"
                            no-caps
                            :label="$t('home.clients')"
                            @click="selectPage('clients')"
                        />
                    </div>
                </div>
            </div>
            <!-- <div class="home-container col-md-3 col-10 q-mx-sm q-my-lg q-pb-xl">
                <div class="row q-pt-xl q-pb-md">
                    <div class="col-12 q-mt-xl text-center">
                        <q-img src="/images/attendance.png" width="55px" />
                    </div>
                </div>
                <div class="row q-py-lg">
                    <div class="col-8 offset-2 text-center">
                        <q-btn
                            size="lg"
                            color="primary"
                            class="border-radius-10 q-px-lg font-18 full-width"
                            no-caps
                            :label="
                                !state.attendanceMode
                                    ? $t('button.checkin')
                                    : $t('button.checkout')
                            "
                            @click="selectPage('attendance')"
                        />
                    </div>
                </div>
            </div> -->
            <div class="home-container col-md-3 col-10 q-ma-sm q-my-lg q-pb-xl">
                <div class="row q-pb-md">
                    <div class="col-12 q-mt-xl text-center">
                        <q-img src="~/assets/images/preference-white.png" width="50px" />
                    </div>
                </div>
                <div class="row q-py-sm">
                    <div class="col-8 offset-2 text-center">
                        <q-btn
                            class="border-radius-10 q-px-lg font-16 home-btn"
                            no-caps
                            :label="$t('button.business')"
                            @click="selectPage('business')"
                        />
                    </div>
                    <div class="col-8 offset-2 text-center q-pt-sm">
                        <q-btn
                            class="border-radius-10 q-px-lg font-16 home-btn"
                            no-caps
                            :label="$t('button.helpdesk')"
                            @click="selectPage('helpdesk')"
                        />
                    </div>
                </div>
            </div>
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import { useRouter } from 'vue-router';
import {
    defineComponent,
    ref,
    reactive,
    computed,
    watch,
    onMounted
} from 'vue';
import { mapGetters } from 'vuex';

export default defineComponent({
    name: 'Home',
    computed: {
        ...mapGetters({
            permission: 'role/getPermissions'
        })
    },
    setup() {
        // store
        const store = useStore();

        // router
        const router = useRouter();

        // data
        let state = reactive({
            attendanceMode: ref(false)
        });

        // computed
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        // watch
        // watch(selectedBusinessId, () => {
        //     updateStates();
        // });

        // methods
        const selectPage = (page: string) => {
            store.dispatch('menu/setSelectedShortcut', page);
            if (page == 'chatting' || page == 'ongoing' || page == 'clients') {
                store.dispatch('menu/setPage', 'helpdesk');
                router.push('helpdesk');
            } else if (page == 'business' || page == 'helpdesk') {
                store.dispatch('menu/setPage', 'preference');
                router.push('preference');
            } else {
                store.dispatch('menu/setPage', page);
                router.push(page);
            }
        };

        const updateStates = () => {
            // set default menu page
            store.dispatch('menu/setPage', 'home', { root: true });

            const findIndex = store.state.attendance.mode.findIndex(
                (element: any) => element.businessId == selectedBusinessId.value
            );
            if (findIndex != -1) {
                state.attendanceMode = true;
            } else {
                state.attendanceMode = false;
            }
        };

        onMounted(updateStates);

        return { state, selectPage };
    }
});
</script>
